﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace BitProgressBar
{
	public delegate void ChangedEventHandler(object sender, EventArgs e);
	
	public partial class BitProgressBar : UserControl
	{
		#region Vars
		private bool AktivCalc;
		#endregion

		#region Events and Constructor
		public BitProgressBar(){
			InitializeComponent();
			CalcBorder();
		}
		

		#endregion

		#region Methods
		

		
		#endregion
		private void ChangeText(TextBox box,int Value){
			int start=box.SelectionStart;
			box.Text=Value.ToString();
			box.SelectionStart=(int)Math.Min(start,box.Text.Length);
		}
		
		private void CalcBorder(){
			if(AktivCalc) return;
			AktivCalc=true;
			int MSB;
			int LSB;
			try{
				MSB=int.Parse(textMSB.Text);
				LSB=int.Parse(textLSB.Text);
			}catch(Exception){
				AktivCalc=false;
				return;
			}
			int Bitanzahl=Math.Abs(MSB-LSB)+1;
			if(Bitanzahl>24){
				int diff=Bitanzahl-24;
				if(MSB>LSB) ChangeText(textMSB,MSB-diff);
				else ChangeText(textLSB,LSB-diff);
				Bitanzahl=24;
			}
			if(MSB>31) ChangeText(textMSB,31);
			if(LSB>31) ChangeText(textLSB,31);
			
			
			int Wertebereich=(int)Math.Round(Math.Pow(2,Bitanzahl));

			progressBar.Hide();
			progressBar.Maximum=Wertebereich-1;
			progressBar.Show();
			
			AktivCalc=false;
		}

		void TextMSBKeyPress(object sender, KeyPressEventArgs e){
			base.OnKeyPress(e);
			string keyInput = e.KeyChar.ToString();
			if ((!Char.IsDigit(e.KeyChar))&&(e.KeyChar != '\b')){
				e.Handled = true;
			}
		}
		
		void TextLSBKeyPress(object sender, KeyPressEventArgs e){
			base.OnKeyPress(e);
			string keyInput = e.KeyChar.ToString();
			if ((!Char.IsDigit(e.KeyChar))&&(e.KeyChar != '\b')){
				e.Handled = true;
			}
		}
		
		void TextMSBTextChanged(object sender, EventArgs e){
			CalcBorder();
		}
		
		void TextLSBTextChanged(object sender, EventArgs e){
			CalcBorder();
		}
		
		public void SetValue(string InD){
			char [] Reverse=InD.ToCharArray();
			Array.Reverse(Reverse);
			InD=new string(Reverse);
			
			try{
				int MSB=int.Parse(textMSB.Text);
				int LSB=int.Parse(textLSB.Text);
				InD=InD.Substring(LSB,MSB-LSB+1);
			}catch(Exception){
				progressBar.Value=0;
				return;
			}
			int Result=0;
			for (int i = 0; i < InD.Length; i++){
				switch (InD[i]){
					case 'H':
					case '1':
						Result+=(int)Math.Pow(2,i);
						break;
				}
				
			}
			progressBar.Value=Result;
		}
	}
}